!================================================================
! file laauxmod.f90
!================================================================
! /netlib/lapack90   Preliminary version November, 1996
!
! file: laauxmod.f90
!             for: auxiliary routines 
!================================================================


MODULE LA_PRECISION
!
!  Defines single and double precision parameters, sp and dp.
!  These values are compiler dependent.
!
   INTEGER, PARAMETER :: SP=KIND(1.0), DP=KIND(1.0D0)
!
END MODULE LA_PRECISION

MODULE LA_AUX
!
CONTAINS
!
LOGICAL FUNCTION LSAME( CA, CB )
!
!  -- LAPACK auxiliary routine (version 2.0) --
!     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
!     Courant Institute, Argonne National Lab, and Rice University
!     September 30, 1994
!
!  Purpose
!  =======
!
!  LSAME  tests if CA is the same letter as CB regardless of case.
!
!  Parameters
!  ==========
!
!  CA      (input) CHARACTER*1
!  CB      (input) CHARACTER*1
!           Characters to be compared.
!
!  .. Scalar Arguments ..
   CHARACTER*1, INTENT(IN) :: CA, CB
!  .. Parameters ..
   INTEGER, PARAMETER :: IOFF=32
!  .. Local Scalars ..
   INTEGER :: INTA, INTB, ZCODE
!  .. Intrinsic Functions ..
   INTRINSIC             ICHAR
!
!  .. Executable Statements ..
!
!  Test if the characters are equal
!
   LSAME = CA == CB
!
!  Now test for equivalence
!
   IF ( .NOT.LSAME ) THEN
!
!     Use 'Z' rather than 'A' so that ASCII can be detected on Prime
!     machines, on which ICHAR returns a value with bit 8 set.
!     ICHAR('A') on Prime machines returns 193 which is the same as
!     ICHAR('A') on an EBCDIC machine.
!
      ZCODE = ICHAR( 'Z' )
!
      INTA = ICHAR( CA )
      INTB = ICHAR( CB )
!
      IF( ZCODE.EQ.90 .OR. ZCODE.EQ.122 ) THEN
!
!        ASCII is assumed - ZCODE is the ASCII code of either lower or
!        upper case 'Z'.
!
         IF( INTA.GE.97 .AND. INTA.LE.122 ) INTA = INTA - 32
         IF( INTB.GE.97 .AND. INTB.LE.122 ) INTB = INTB - 32
!
      ELSE IF( ZCODE.EQ.233 .OR. ZCODE.EQ.169 ) THEN
!
!        EBCDIC is assumed - ZCODE is the EBCDIC code of either lower or
!        upper case 'Z'.
!
         IF( INTA.GE.129 .AND. INTA.LE.137 .OR. &
!            INTA.GE.145 .AND. INTA.LE.153 .OR. &
             INTA.GE.162 .AND. INTA.LE.169 ) INTA = INTA + 64
         IF( INTB.GE.129 .AND. INTB.LE.137 .OR. &
             INTB.GE.145 .AND. INTB.LE.153 .OR. &
             INTB.GE.162 .AND. INTB.LE.169 ) INTB = INTB + 64
!
      ELSE IF( ZCODE.EQ.218 .OR. ZCODE.EQ.250 ) THEN
!
!        ASCII is assumed, on Prime machines - ZCODE is the ASCII code
!        plus 128 of either lower or upper case 'Z'.
!
         IF( INTA.GE.225 .AND. INTA.LE.250 ) INTA = INTA - 32
         IF( INTB.GE.225 .AND. INTB.LE.250 ) INTB = INTB - 32
      END IF
      LSAME = INTA == INTB
   END IF
END FUNCTION LSAME

SUBROUTINE ERINFO(LINFO, SRNAME, INFO)
!  .. Scalar Arguments ..
   CHARACTER( LEN = * ), INTENT(IN) :: SRNAME
   INTEGER             , INTENT(IN) :: LINFO
   INTEGER             , INTENT(INOUT), OPTIONAL :: INFO
!
!  .. Executable Statements ..
!
   IF( PRESENT(INFO) ) INFO = LINFO
   IF( LINFO < 0 .OR. LINFO>0 .AND. .NOT.PRESENT(INFO) )THEN
      WRITE (*,*) 'Program terminated in LAPACK_90 subroutine ', SRNAME
      WRITE (*,*) 'Error indicator, INFO = ', LINFO
      STOP
   END IF 
END SUBROUTINE ERINFO
!
END MODULE LA_AUX
